config/routes.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

require 'sidekiq/web'

class ActionDispatch::Routing::Mapper
  def draw_custom
    ["custom/config/routes.rb", "../custom/config/routes.rb"].each do |filename|
      instance_eval(File.read(Rails.root.join(filename))) if File.file?(filename)
    end
    
  end
end

Scumblr::Application.routes.draw do

  draw_custom

  if(User.devise_modules.include?(:omniauthable))
    devise_for :users , :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }
    match '/users/auth/openid_connect/callback' => 'users/omniauth_callbacks#openid_connect_callback', via: [:get, :post]
    match '/users/auth/openid_connect' => 'users/omniauth_callbacks#openid_connect', via: [:get, :post], as: "openid_connect"
  else
    devise_for :users
  end

  resources :users do
    member do
      post 'toggle_admin'
    end
  end

  resources :system_metadata
  resources :events, only: [:index, :show] do
    collection do
      post 'search' => 'events#index'
      get 'search' => 'events#index'
    end

  end
  resources :flags

  get "user_saved_filters/create"
  get "user_saved_filters/destroy"
  get "saved_filters/new"
  get "saved_filters/destroy"

  resources :saved_filters do
    member do
      post :add
      post :remove
    end
  end



  resources :results do
    collection do
      post 'update_multiple'
      post 'bulk_add'
      post 'search' => 'results#index'
      get 'search' => 'results#index'
      get 'tags/:tag', to: 'results#index', as: :tag
      get 'dashboard'
      get 'workflow_autocomplete'
      post 'update_table_columns'

      get 'expandall', to: 'results#expandall'
      get 'show', to: 'results#show', as: :show_by_name
      get 'expandvulns', to: 'results#expandvulns'
      get 'expandclosedvulns', to: 'results#expandclosedvulns'
      post 'create_vulnerability', to: 'results#create_vulnerability'
    end

    member do
      post 'change_status/:status_id'=>"results#update_status", as: 'update_status'
      post 'comment'  => 'results#comment', :as=> :comment
      post 'tag'  => 'results#tag'
      post 'flag'  => 'results#flag'
      post 'action/:result_flag_id/step/:stage_id'  => 'results#action', as: 'action'
      post 'assign'  => 'results#assign'
      post 'subscribe'  => 'results#subscribe'
      post 'unsubscribe'  => 'results#unsubscribe'
      delete 'tags/:tag_id', to: 'results#delete_tag', as: :delete_tag
      post :add_attachment
      delete 'attachment/:attachment_id', to: 'results#delete_attachment', as: :delete_attachment
      post 'generate_screenshot' => "results#generate_screenshot"
      post 'update_screenshot'
      get 'update_screenshot'
      match 'update_metadata', via: [:get, :post]
      match 'get_metadata', via: [:get, :post]
      get 'summary', to: 'results#summary'
      
      match 'render_metadata_partial', via: [:get, :post]
    end


  end

  resources :tags, only: :index

  resources :tasks do
    collection do
      get 'options', to: 'task_types#options'
      get 'run', to: 'tasks#run'
      post 'bulk_update'
      get 'expandall', to: 'tasks#expandall'
      get :events
    end


    member do
      get 'run', to: 'tasks#run'
      get 'get_metadata'
      post 'enable', to: 'tasks#enable'
      post 'disable', to: 'tasks#disable'
      get 'summary', to: 'tasks#summary'

    end

    member do
      get 'options', to: 'task_types#options'
    end
  end

  resources :statuses do
    member do
      post 'set_default'
    end
  end

  get 'status', to: 'status#status'
  get 'about', to: 'status#about'

  root to: "results#index"

  admin_constraint = lambda do |request|
    request.env['warden'].authenticate? && request.env['warden'].user.admin?
  end

  constraints admin_constraint do
    mount Workflowable::Engine => "/workflowable", as: :workflowable
    mount Sidekiq::Web => '/sidekiq'
    get 'errors', :to => "event_groups#index"
    get 'about', to: 'status#about'
  end

end

app/models/flag.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.


class Flag < ActiveRecord::Base
  has_many :result_flags
  has_many :results, through: :result_flags
  has_many :subscribers, as: :subscribable
  belongs_to :workflow, class_name: "Workflowable::Workflow"

  validates :name, presence: true
  validates :name, uniqueness: true

  def subscriber_list
    subscribers.where(:user_id=>nil).map(&:email).join(",")
  end

  def subscriber_list=(emails)
    self.subscribers = emails.split(",").map do |email|
      self.subscribers.where(:email=>email.downcase.strip).first_or_initialize
    end
  end

end

app/controllers/results_controller.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

require 'open-uri'

class ResultsController < ApplicationController
  authorize_resource
  skip_before_filter :verify_authenticity_token, :only=>[:index, :update_screenshot]

  before_filter :load_result, only: [:show, :edit, :update, :destroy, :tag, :action,
                                     :flag, :update_status, :comment, :delete_tag, :assign, :add_attachment, :delete_attachment,
                                     :subscribe, :unsubscribe, :update_screenshot,
                                     :update_metadata]

  skip_authorize_resource :only=>:update_screenshot
  skip_authorization_check :only=>:update_screenshot
  skip_before_filter :authenticate_user!, :only=>:update_screenshot

  def summary
    @result = Result.find(params[:id])
    respond_to do |format|
      format.js
    end
  end

  def expandall
    array_of_ids = params[:result_ids].split(',').map(&:to_i)
    @results = Result.find(array_of_ids.to_a).index_by(&:id).slice(*array_of_ids).values
    respond_to do |format|
      format.js
    end
  end

  def render_metadata_partial
    @result = Result.cached_find(params[:id])
    @partial = params[:partial].to_s
    @target = params[:target]




    if(!@partial.match(/\A[A-Za-z0-9_]+\z/))
      render text: "Invalid Partial"
      return
    end
  
    if(params.try(:[],"filter") && @result.metadata.class == Hash)      
      params.try(:[],"filter").each do |key,values|

        values.reject!{|x| x.blank?}
        next if values.blank?
        filter = key.split(":")
        filter_on=nil
        filter_on = params["filter_on"][key].split(":") if params.try(:[],"filter_on").try(:[],key)

        @result.filter_metadata(@result.metadata, filter, values, filter_on)

      end
      
    end

    

    respond_to do |format|
      format.html { render layout: false}
      format.js
    end

  end


  # def expandvulns
  #   #puts params.inspect
  #   @result = Result.cached_find(params[:id])
  #   respond_to do |format|
  #     format.js
  #   end
  # end

  # def expandclosedvulns
  #   #puts params.inspect
  #   @result = Result.cached_find(params[:id])
  #   respond_to do |format|
  #     format.js
  #   end
  # end

  def create_vulnerability
    @result = Result.cached_find(params[:result_id])
    @title = params[:type]
    vuln = Vulnerability.new
    #if !["observation", "High", "Medium", "Low", "Critical"].index(params[:severity]).nil?
    vuln.severity = params[:severity]
    vuln.type = params[:type]
    vuln.url = params[:url]
    vuln.path = params[:path]
    vuln.jira_ids = params[:jira_ids]
    vuln.details = params[:details]
    @result.update_vulnerabilities([vuln])
  end

  # GET /results
  # GET /results.json
  def index
    @menu_item = "results"
    @index_columns = session[:results_index_columns] || Rails.configuration.try(:results_index_columns) || [:screenshot,:title, :status_id, :domain, :link, :created_at, :updated_at]
    perform_search




    #Save is here because if we render/return in perform_search we end up double rendering
    if(params[:commit] == "Save")
      #We delete commit to prevent the parameter value from being picked up in pagination, etc.
      params.delete(:commit)
      render 'saved_filters/new'
      return
    end

    # @results = @results.page(params[:page]).per(params[:per_page]) if @results

    #We delete commit to prevent the parameter value from being picked up in pagination, etc.
    params.delete(:commit)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @results.to_json }
      format.csv { render text: @results.to_csv }
    end
  end


  def dashboard
    #Add boxes at the top with Quick facts (New today (delta))......
    # Task/Searches with highest/lowest signal to noise ratio
    # Task/Searches with most/least raw actionable results
    #
    @menu_item = "dashboard"
    @results = Result.all
    @flags = Flag.all
    @results_by_date = Result.where(:id=>@results).group("date(created_at)").order("date(created_at)").count
    @statuses= Status.all
    @tasks = Task.all


    @flag_counts = ResultFlag.includes(:flag).where(:result_id=>@results).group("flags.name").references(:flags).count

    @task_results_total = Task.joins(:task_results).group("tasks.id").count
    @task_results_24_hours = Task.joins(:task_results).group("tasks.id").where("task_results.created_at > ?",1.day.ago).count
    @task_results_7_days = Task.joins(:task_results).group("tasks.id").where("task_results.created_at > ?",7.days.ago).count
    @task_results_30_day_trend = Task.joins(:task_results).where("task_results.created_at > ?",30.days.ago).group("tasks.id", "date(task_results.created_at)").order("date(task_results.created_at)").count #.count(:group=>["tasks.id", "date(task_results.created_at)"], :order=>"date(task_results.created_at)")


    @task_results_without_flags = Task.joins(:results).where.not(:id=>ResultFlag.select(:id)).references(:results).group("tasks.id").count
    @task_results_with_flags = Task.joins(:results=>:flags).group(["tasks.id", "flags.id"]).count


    render layout: "dashboard"
  end


  # GET /results/1
  # GET /results/1.json
  def show
    if(@result.nil?)
      redirect_to results_path, notice: "Unable to find result"
      return
    elsif(@result && params[:url] && !params[:id])
      redirect_to @result
      return
    end

    @comments = @result.root_comments.includes([:user,:children])

    @associated_objects = {
      task_results: {:method=>:task_results, :includes=>:task, :link=>{:method=>:task_id, :path=>:task_url, :params=>[:task_id]}, :attributes=>[:task_name, :task_type, :query, :created_at], name:"Tasks"},
      events: {:method=>:events, :includes=>[:user, :event_changes], :link=>{:method=>:id, :path=>:event_url, :params=>[:id], :sort_key=>:id}, :attributes=>[:date, :field_name, :action, :old_value, :new_value, :user], :sort_keys=>[:date,nil, :action, :old_value, :new_value,:user_id], name:"Events"},
      result_attachments: {
        :method=>:text_attachments,
        :includes=>[],
        :link=>{:label=>:filename, :method=>:attachment_file_name, :path=>:get_result_attachment_expiring_url, :params=>[:id], :sort_key=>:attachment_file_name},
        :attributes=>[:pretty_filesize, :created_at],
        :sort_keys=>[:attachment_file_size, :created_at],
        :labels=>[:size],
        :actions => [{label: "Destroy", :path => :delete_attachment_result_path, params:[:result, :id], :confirm=>"Are you sure?", :method=>:delete}],
      name:"File Attachments"}
    }

    if(params[:action_name].present?)
      @associated_objects = @associated_objects.select{|k,obj| obj[:method].to_s == params[:action_name].to_s}
    end

    @associated_objects.each do |key, result_set|
      sort = params[:sort].to_i == 0 ? result_set.try(:[], :link).try(:[],:sort_key) : result_set.try(:[],:sort_keys).try(:[],params[:sort].to_i - 1)

      get_paginated_results(@result, result_set[:method], {includes: result_set[:includes], order: sort || :id , direction: params[:sort_dir] || :desc})
    end



    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @result }
      format.js
    end
  end

  # GET /results/new
  # GET /results/new.json
  def new
    @result = Result.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @result }
    end
  end

  # GET /results/1/edit
  def edit
  end

  # POST /results
  # POST /results.json
  def create
    @result = Result.new(result_params)
    @result.current_user = current_user
    @result.metadata ||= {}



    respond_to do |format|
      if @result.save

        format.html { redirect_to @result, notice: 'Result was successfully created.' }
        format.json { render json: @result, status: :created, location: @result }
      else
        format.html { render action: "new" }
        format.json { render json: @result.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /results/1
  # PUT /results/1.json
  def update

    @result.assign_attributes(result_params)

    respond_to do |format|

      if(@result.save)
        format.html { redirect_to @result, notice: 'Result was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @result.errors, status: :unprocessable_entity }
      end
    end
  end

  def update_status
    @status = Status.find(params[:status_id])
    @old_status = Status.where(id: @result.status_id).first.try(:name)

    @result.status_id= @status.id

    if(@result.save)
      @notice = "Status updated."
    else
      @notice = "Could not update status"
    end


    respond_to do |format|

      format.js
    end
  end

  # DELETE /results/1
  # DELETE /results/1.json
  def destroy
    result_id = @result.id
    @result.destroy
    Event.create(action: "Deleted", user_id: current_user.id, eventable_type: "Result", eventable_id: result_id )

    respond_to do |format|
      format.html { redirect_to results_url }
      format.json { head :no_content }
    end
  end

  def comment
    @comment = Comment.build_from( @result, current_user.id, params[:comment] )


    if(params[:parent_id] && parent = Comment.find_comments_for_commentable(Result, @result).find(params[:parent_id]))

app/helpers/results_helper.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.
#require 'aws-sdk'

module ResultsHelper

  def get_result_attachment_expiring_url(id)
    ResultAttachment.find(id).get_expiring_url
  end

  def make_link(result)
    if result.metadata.try(:[], "sketchy_response").present?
      url = URI(result.metadata["sketchy_response"])
      parsed_url = url.path.match(/\/([^\/]+)\/(.+)/)
      aws_resource = AWS::S3.new({:s3_endpoint=>"s3.amazonaws.com", :region=>"us-west-1"})
      obj = aws_resource.buckets[parsed_url[1]].objects[parsed_url[2]] # no request made
      return obj.url_for(:read, :expires => 10*60)
    end
  end
end

app/views/results/_subscriber_list.html.erb
<h2>Subscribers</h2>
<% if @result.subscribers.count == 0 %>
  <p>No subscribers</p>
<% else %>
  <% @result.subscribers.each do |s| %>
    <%= s.subscriber_email %>
    (<%= link_to "X", unsubscribe_result_path(:user_id=>s.user_id), remote: true, method: :post %>)<br/>
  <% end %>
<% end %>
<h3>Add subscriber</h3>
<%= form_tag subscribe_result_path(@result), remote: true do %>
  <input type="hidden" class="remote_select2" data-autosubmit="true" data-attribute="email" data-object="users" data-path="<%= users_path %>" name="user_id" />
<% end %>

app/views/results/_subscription.html.erb
<% if @result.subscribers.where(:user_id=>current_user).present? %>
  <%= link_to "Unsubscribe", unsubscribe_result_path, remote: true, method: :post %>
  (<%= link_to @result.subscribers.count, "#", :data => { "reveal-id" => 'subscribers-modal'} %>)
<% else %>
  <%= link_to "Subscribe", subscribe_result_path, remote: true, method: :post %>
  (<%= link_to @result.subscribers.count, "#", :data => { "reveal-id" => 'subscribers-modal'} %>)
<% end %>
<div id="subscribers-modal" class="reveal-modal" data-reveal>
  <%= render 'subscriber_list' %>
</div>

app/views/results/_update_workflow.html.erb
<div class="preloader"></div>
<header class="popup-header">
  <div class="row">
    <div class="large-12 columns">
      <h4>Update Workflow</h4>
    </div>
  </div>
</header>
<div class="row">
  <div class="large-12 columns">
    <% if @errors && params[:options].present? %>
      <% @errors.each do |error| %>
        <div data-alert="" class="alert-box">
          <p>Errors For:
            <%= error.keys.first.to_s.titleize %></p>
          <ul>
            <% error[error.keys.first].each do |e| %>
              <li><%= e.to_s.titleize %></li>
            <% end %>
          </ul><a href="#" class="close">×</a>
        </div>
      <% end %>
    <% end %>
    <%= form_for @result, :url=>action_result_path(@result, @result_flag, @next_stage), method: :post, remote: true do |f| %>
      <%= render partial: "workflow_options" %>
      <%= f.submit :class=>"button tiny preload" %>
      <%= button_tag "Cancel", :type=>:button, :class=>"button secondary tiny close-modal" %>
    <% end %>
  </div>
</div>

app/views/results/_workflow_options.html.erb
<% @options.each do |action_type, options| %>
  <% options.each do |k,v| %>
    <% if v.length > 0 %>
      <h5><%= k.titleize %></h5>
    <% end %>
    <%= fields_for "options[#{action_type}][#{k}]", OpenStruct.new({}) do |options_form| %>
      <% v.each do |key, value| %>
        <div class="field">
        
          <% if value[:value].blank? || value[:user_specified] ==true %>            
            <%= render partial: value["type"] ? "shared/workflowable/fields/#{value["type"]}" : "shared/workflowable/fields/string", locals: {f: options_form, label:value.try(:[],:name) || key, value_hash:value, value: params.try(:[], action_type).try(:[],k).try(:[],key) || value[:value] ||  value[:default], key:key, workflow_id: @flag.workflow_id, action_id:k} %>
          <% else %>
            <!-- <b><%= key.to_s.titleize %>: </b>
              <%#= value.try(:[],:value).try(:[],:name) if value.try(:[],:value).class == ActionController::Parameters %>
              <%#= value.try(:[],:value) if value.try(:[],:value).class != ActionController::Parameters %> -->
          <% end %>
        </div>
      <% end %>
    <% end %>
  <% end %>
<% end %>

app/views/results/index.html.erb
<%= javascript_tag do %>
  window.localStorage.setItem('expanded_all_results', "false");
  $(document).ready(function () {
    $("#loading").hide();
  });
$(function(){
  $('#expandall_arrow').click(function(){
        $("#loading").show();
    });

  $(document).ajaxStop(function(){
        $("#loading").hide();
    });
    });
<% end %>
<div id="loading" class="loading" style="display:nont">Loading&#8230;</div>
<div id="flash_messages">
  <%= render :partial=>"shared/notification", :locals => {:message=>@errors} if @errors.present? %>
</div>
<nav class="tab-bar">
  <section class="tab-bar-section">
    <h1>Results
      <span class="small-heading">
        <% if @results %>
          <%= page_entries_info @results  %>
          <% if @results.total_count != @total_result_count %><b>(<%= @total_result_count - @results.total_count %>
              results  filtered)</b><% end %>
        <% end %>
      </span>
    </h1>
  </section>
  <section class="buttons button-bar">
    <ul class="button-group">
      <li><a data-dropdown="table_columns_dropdown" aria-controls="table_columns_dropdown" aria-expanded="false" class="fi-widget view-button"></a>
        <div id="table_columns_dropdown" data-dropdown-content class="f-dropdown content f-dropdown-wide" aria-hidden="true" tabindex="-1">
          <%= form_tag update_table_columns_results_path do %>
            <h3>Display Fields</h3>
            <%= label_tag do %>Built-in Fields

              <%= hidden_field_tag "columns[built_in]", @index_columns.select{|c| !c.to_s.starts_with("metadata:")}.join(", "), {class: 'select2-tags', multiple:true, data:{tags: Result.valid_column_names}} %>
            <% end %>
            <%= label_tag do %>Metadata <span data-tooltip aria-haspopup="true" class="has-tip tip-left" title="Show metadata fields.<br/>Nested fields can be displayed by separating with ':'.<br/>
                 Examples: 'status_code'<br/>
                'scan:latest:timestamp'<br/>
                 Note: The same value can be used in the metadata search field to filter to only results containing a value for this field. Displaying fields containing large amounts of data could significantly impact performance."><i class="fi-info"></i></span>
              <%= hidden_field_tag "columns[metadata_fields]", @index_columns.select{|c| c.to_s.starts_with("metadata:")}.map{|c| c.gsub("metadata:", "")}.join(", ") , {class: "select2-tags", multiple: true} %>
            <% end %>
            <%= submit_tag "Update", class: "button tiny" %> <%= submit_tag "Update and Set Default", class: "button tiny" %>
          <% end %>
        </div>
      </li>
    </ul>
  </section>
  <section class="pagination">
    <%= paginate @results, :method=>:post, :params=> nil, :outer_window => 3, :window=>1, :remote=> (defined? remote)? remote : false if @results%>
  </section>
  <section class="buttons button-bar">
    <ul class="button-group">
      <li><%= link_to "", results_path(:view=>"list"), :class=>"view-button fi-list-bullet" %></li>
      <li><%= link_to "", results_path(:view=>"tiles"), :class=>"view-button fi-thumbnails" %></li>
    </ul>
  </section>
</nav>
<div class="panel" style="display:none" id="update_all_from_page_header">
  <% if @results %>
    <p>All <%= @results.length %> results on this page selected.
    <%= link_to "Select all #{@results.total_count} results that match this filter", "#", :id=>"update_all_from_query_link" %></p>
  <% end %>
</div>
<div class="panel" style="display:none" id="update_all_from_query_header">
  <% if @results %>
    <p>All <%= @results.total_count %> results in this search selected.
      <%= link_to "Clear selection", "#", :id=>"clear_selection" %></p>
  <% end %>
</div>
<% if @view == "tiles" %>

  <%= render 'results_tiles' if @results %>
<% else %>
  <%= render 'results_table' if @results %>
<% end %>

<%= content_for :sidebar do %>
  <div class="sidebar" id="result_action_panel" style="display:none">
    <nav class="tab-bar">
      <section class="tab-bar-section">
        <h1>Actions
        </h1>
      </section>
    </nav>
    <section class="panel sidepanel">
      <%= form_tag update_multiple_results_path, method: :post, :id=>"update_multiple_form" do %>
        <%= label_tag do %>Status
          <%= select_tag :status_id, options_from_collection_for_select(Status.all, "id", "name"), {:prompt => 'Please select', class: 'select2'} %>
        <% end %>
        <%= label_tag do %>Tags
          <%= hidden_field_tag "tags", "", {class: "remote_select2", "data-multiple"=>true, "data-id-attribute"=>"name_value" , "data-parse-initial"=>"true", "data-create-new"=>"true", "data-object"=>"tags", "data-attribute"=>"name_value" , "data-path"=>tags_path} %>
        <% end %>
        <%= label_tag "Remove" do %>
          <%= check_box_tag :remove_tags, '1', false %> Remove Tag(s)
        <% end %>
        <%= label_tag do %>Assignee
          <%= select_tag :assignee_id, options_from_collection_for_select(User.all, :id, :email), {:prompt => 'Please select', class: "select2"} %>
        <% end %>
        <%= hidden_field_tag :q, params[:q].to_json %>
        <%= hidden_field_tag :update_all_from_query, false, {:id=>'update_all_from_query'} %>
        <% button_options = ["Update", "Update and Generate Screenshot", "Update and Force Generate Screenshot"] %>
        <%= split_button  button_options, :button_class=>'small', :link_class=>'update_multiple_button' %>
        <% if(can? :destroy, Result) %>
          <%= submit_tag "Delete Results", class: "button alert small update_multiple_button", data: { confirm: "Are you sure you want to delete the selected results?" } %>
        <% end %>
      <% end %>
    </section>
  </div>
<% end %>
<%= paginate @results, :method=>:post, :params=> nil, :outer_window => 3, :window=>1, :remote=> (defined? remote)? remote : false if @results %>
<br />
<%= link_to 'New Result', new_result_path, class: "button" %>
<%= link_to "Bulk Add Results", "#", :class=>"button", data:{"reveal-id"=>"bulk_add_form"} %>
<div id="bulk_add_form" class="reveal-modal custom-modal" data-reveal>
  <header class="popup-header">
    <div class="row">
      <div class="large-12 columns">
        <h4>Bulk Add Results</h4>
      </div>
    </div>
  </header>
  <div class="row">
    <div class="large-12 columns">
      <%= form_tag bulk_add_results_path do |f| %>
        <%= text_area_tag :results %>
        <%= label_tag do %>Tags
          <%= hidden_field_tag "tags", "", {class: "remote_select2", "data-multiple"=>true, "data-id-attribute"=>"name_value" , "data-parse-initial"=>"true", "data-create-new"=>"true", "data-object"=>"tags", "data-attribute"=>"name_value" , "data-path"=>tags_path} %>
        <% end %>
        <%= label_tag "tag_new_only" do %>
          <%= check_box_tag :tag_new_only, '1', false %> Only Tag New Results
        <% end %>
        <%= submit_tag "Submit", :class=>"button tiny preload" %>
        <%= button_tag "Cancel", :type=>:button, :class=>"button secondary tiny close-modal" %>
      <% end %>
    </div>
  </div>
</div>
<%= content_for :sidebar do %>
  <div class="sidebar">
    <nav class="tab-bar">
      <section class="tab-bar-section">
        <h1>Filter
        </h1>
      </section>
    </nav>
    <section class="panel sidepanel">
      <%= search_form_for @q, :url=>search_results_path, :method=>:post, :authenticity_token => false, id:"search_form"  do |f| %>
        <%= render partial: 'search_fields', locals: {f: f}%>
        <%= f.submit class: "button small" %>
        <%= f.submit "Clear Search", class: "button secondary small" %>
        <%= f.submit "Save", class: "button secondary small" %>
        <%#= f.button "Reset", type: :reset, class:"secondary" %>
      <% end %>
    </section>
  </div>
<% end %>

app/views/results/new.html.erb
<h1>New result</h1>
<%= render 'form' %>